unit GridFunctions;

interface
  uses grids, comctrls, sysutils;
                                                                        
  procedure DeleteRow(Var Grid:TStringGRid;TargetRow:Integer);
  Procedure InsertRow(Var Grid:TStringGrid;Location:Integer);
  Procedure DupeGrid(Sourcegrid:TStringGRid; Var Targetgrid:TStringGrid);
  Procedure Cleargrid(Var Grid:TstringGrid);
  Procedure SaveGrid(Grid:TstringGrid;Filename:STring);
  Procedure LoadGrid(var Grid:TstringGrid;Filename:STring);
  Procedure SortGridAscend(Var Grid:TStringGrid;KeyCol:integer);
  Procedure SortGridDecend(Var Grid:TStringGrid;KeyCol:integer);
  Procedure PrintGrid(Grid:TStringGrid);
  Function MoveRowUp(var Grid:TstringGrid;Row:Integer):boolean;
  Function MoveRowDown(var Grid:TstringGrid;Row:Integer):boolean;
Function CellLeft(grid:TstringGrid;Col:Integer):integer;
  Function CellTop(grid:TstringGrid;Row:Integer):integer;
implementation


procedure DeleteRow(Var Grid:TStringGRid;TargetRow:Integer);
var
  Row,Col:integer;
begin
  If Grid.Rowcount > 1 then
  begin
    For Col := 0 to Grid.ColCount-1 do
      Grid.Cells[Col,TargetRow] :='';
    For Row := TargetRow to Grid.RowCount-2 do
      For Col := 0 to Grid.ColCount-1 do
        Grid.Cells[Col,Row] :=Grid.Cells[Col,Row+1];
   end;
   For Col := 0 to Grid.ColCount-1 do
    Grid.Cells[Col,Grid.RowCount-1] :='';
  Grid.RowCount:= Grid.RowCount -1;
end;

Procedure InsertRow(Var Grid:TStringGrid;Location:Integer);
var
  Col,Row:Integer;
begin
  Grid.RowCount := Grid.Rowcount+1;
  For Row := Grid.RowCount-1 downto Location+1 do
    Grid.Rows[Row] := Grid.Rows[Row-1];
  For Col := 0 to Grid.ColCount -1 do
    GRid.Cells[Col,Location] := '';
end;



Procedure DupeGrid(Sourcegrid:TStringGRid; Var Targetgrid:TStringGrid);
var
  Row:Integer;
begin
  TargetGrid.RowCount := SourceGrid.RowCount;
  TargetGrid.ColCount := SourceGrid.ColCount;
  TargetGrid.FixedCols := SourceGrid.FixedCols;
  TargetGrid.FixedRows := SourceGrid.FixedRows;
  For Row := 0 to SourceGrid.RowCount-1 do
    TargetGrid.Rows[row].CommaText := SourceGrid.Rows[row].CommaText;
end;

Procedure Cleargrid(Var Grid:TstringGrid);
var
  Row,Col:Integer;
begin
  For Row := 0 to Grid.Rowcount -1 do
    For Col := 0 to Grid.ColCount -1 do
      Grid.cells[col,row] := '';
  Grid.rowcount :=Grid.FixedCols+1;
end;

Procedure SaveGrid(Grid:TstringGrid;Filename:STring);
var
  Row:Integer;
  F:TextFile;
begin
  AssignFile(F,Filename);
  Rewrite(F);
  For Row := Grid.fixedRows to Grid.Rowcount-1 do
    Writeln(F,Grid.Rows[Row].Commatext);
  closeFile(F);
end;

Procedure LoadGrid(var Grid:TstringGrid;Filename:STring);
Var
  F:TextFile;
  temp:String;
begin
  AssignFile(F,FileName);
  reset(F);
  While not EOF(F) do
  begin
    Readln(F,Temp);
    If Grid.Cells[0,Grid.RowCount-1] <> '' then
      Grid.Rowcount := Grid.RowCount+1;
    Grid.Rows[Grid.RowCount-1].CommaText := Temp;
  end;
  Closefile(F);
end;

Procedure SortGridAscend(Var Grid:TStringGrid;KeyCol:integer);
var
  Temp:String;
  Flipped:Boolean;
  Row:Integer;
begin
  Flipped := True;
  While Flipped do
  begin
    Flipped:=False;
    For Row := Grid.FixedRows to Grid.RowCount-2 do
      If grid.Cells[KeyCol,Row] > grid.Cells[KeyCol,Row+1] then
      begin
        Flipped := True;
        Temp := Grid.Rows[Row].commatext;
        Grid.Rows[Row].commatext := Grid.Rows[Row+1].commatext;
        Grid.Rows[Row+1].commatext := Temp;
      end;
  end;
end;

Procedure SortGridDecend(Var Grid:TStringGrid;KeyCol:integer);
var
  Temp:String;
  Flipped:Boolean;
  Row:Integer;
begin
  Flipped := True;
  While Flipped do
  begin
    Flipped:=False;
    For Row := Grid.FixedRows to Grid.RowCount-2 do
      If grid.Cells[KeyCol,Row] < grid.Cells[KeyCol,Row+1] then
      begin
        Flipped := True;
        Temp := Grid.Rows[Row].commatext;
        Grid.Rows[Row].commatext := Grid.Rows[Row+1].commatext;
        Grid.Rows[Row+1].commatext := Temp;
      end;
  end;
end;

Procedure PrintGrid(Grid:TStringGrid);
var
  Richedit1:TRichedit;
  Row:Integer;
begin
  Richedit1 := Trichedit.Create(nil);
  Richedit1.Lines.Clear;
  For Row := 0 to Grid.RowCount-1 do
  begin
    Richedit1.Lines.Add(Grid.Cells[0,Row]+#9+
                        Grid.Cells[1,Row]+#9+
                        Grid.Cells[2,Row]+#9+
                        Grid.Cells[3,Row]+#9+
                        Grid.Cells[4,Row]+#9+
                        Grid.Cells[5,Row]+#9+
                        Grid.Cells[6,Row]+#9+
                        Grid.Cells[7,Row]+#9+
                        Grid.Cells[8,Row]+#9+
                        Grid.Cells[9,Row]+#9+
                        copy(Grid.Cells[10,Row],1,6)+#9+
                        Grid.Cells[11,Row]+#9+
                        copy(Grid.Cells[12,Row],1,6)+#9+
                        Grid.Cells[13,Row]+#9+
                        Grid.Cells[14,Row]);
  end;
  Richedit1.Print('');
end;

Function MoveRowUp(var Grid:TstringGrid;Row:Integer):Boolean;
var
  Temp:String;
begin
  If Row > Grid.FixedRows then
  begin
    Temp:= Grid.Rows[Row-1].commatext;
    Grid.Rows[Row-1].commatext := Grid.Rows[Row].commatext;
    Grid.Rows[Row].commatext := temp;
    Result := True;
  end
  else
    Result := False;

end;

Function MoveRowDown(var Grid:TstringGrid;Row:Integer):boolean;
var
  Temp:String;
begin
  If Row+1 < Grid.RowCount then
  begin
    Temp:= Grid.Rows[Row+1].commatext;
    Grid.Rows[Row+1].commatext := Grid.Rows[Row].commatext;
    Grid.Rows[Row].commatext := temp;
    Result := True;
  end
  else
    Result := False;
end;


Function CellLeft(grid:TstringGrid;Col:Integer):integer;
var
  temp:Integer;
  cCol:Integer;
begin
  Temp := 0;
  For cCol := 0 to Col-1 do
    Temp := Temp+Grid.ColWidths[cCol]+2;
  Result := Temp+grid.Left;
end;

Function CellTop(grid:TstringGrid;Row:Integer):integer;
var
  temp:Integer;
  cRow:Integer;
begin
  Temp := 0;
  For cRow := 0 to Row-1 do
    Temp := Temp+Grid.RowHeights[cRow]+2;
  Result := Temp + Grid.top;
end;


end.
